"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var utils_1 = require("./utils");
function default_1(_a) {
    var _b = _a.projectNameSpace, projectNameSpace = _b === void 0 ? '' : _b, _c = _a.entryFilePath, entryFilePath = _c === void 0 ? undefined : _c;
    var plugin = {
        name: 'source-map-revamp',
        // transform(_source: string, moduleID: string): { code: string; map: string } | null {
        //   if (moduleID.match(new RegExp(projectNameSpace + '\.js$', 'im')) !== null) {
        //     const sourceMap = getSourceMapOfModule(moduleID);
        //     sourceMap.sources = [];
        //     return {
        //       code: _source,
        //       map: JSON.stringify(sourceMap),
        //     };
        //   }
        //   return null;
        // },
        ongenerate: function (_unused, generate) {
            if (!utils_1.isNil(generate.map) && utils_1.isArray(generate.map.sources) && generate.map.sources.length > 0) {
                if (utils_1.isString(entryFilePath)) {
                    var lastSourceIndex = generate.map.sources.length - 1;
                    var lastSource = generate.map.sources[lastSourceIndex];
                    var entryModuleNameRegEx = new RegExp(projectNameSpace + '\.[jt]s$', 'i');
                    if (lastSource.match(entryModuleNameRegEx) !== null) {
                        generate.map.sources[lastSourceIndex] = lastSource.replace(entryModuleNameRegEx, path.basename(entryFilePath));
                        generate.map.sourcesContent[lastSourceIndex] = utils_1.readFile(entryFilePath);
                    }
                }
                generate.map.sourceRoot = projectNameSpace;
                generate.map.sources = generate.map.sources.map(function (source) {
                    if (utils_1.isString(source)) {
                        return source.replace(/^\.\../, '').replace(/^\.compile./i, '').replace(/^ngc-compiled./i, '');
                    }
                    return source;
                });
            }
        },
    };
    return plugin;
}
exports.default = default_1;
