"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var source_map_1 = require("source-map");
var typescript_1 = require("typescript");
var utils_1 = require("./utils");
function removeSourceMaps(content) {
    if (!utils_1.isString(content)) {
        return content;
    }
    return content.replace(/^\/+#\s*sourceMappingURL=.*$/igm, '');
}
exports.removeSourceMaps = removeSourceMaps;
function getTranspileOptions(overwriteOptions) {
    return utils_1.mergeInto({
        compilerOptions: {
            sourceMap: true,
            target: typescript_1.ScriptTarget.ES5,
            module: typescript_1.ModuleKind.ES2015,
        },
    }, overwriteOptions);
}
exports.getTranspileOptions = getTranspileOptions;
function transpileModule(moduleFilePath, options, destFilePath) {
    return __awaiter(this, void 0, void 0, function () {
        var moduleContent, result, err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (utils_1.isNil(destFilePath)) {
                        destFilePath = moduleFilePath;
                    }
                    if (utils_1.isNil(options.compilerOptions)) {
                        throw new Error('Error: Transpile requires compiler options!');
                    }
                    moduleContent = utils_1.readFile(moduleFilePath);
                    options.fileName = moduleFilePath;
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, typescript_1.transpileModule(moduleContent, options)];
                case 2:
                    result = _a.sent();
                    utils_1.writeFile(destFilePath, result.outputText);
                    if (options.compilerOptions.sourceMap) {
                        debugger;
                        generateSourceMapForModule(moduleFilePath, destFilePath, result.sourceMapText);
                    }
                    return [3 /*break*/, 4];
                case 3:
                    err_1 = _a.sent();
                    throw new Error("Error in transpile module \"" + path.basename(moduleFilePath) + "\": " + err_1);
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.transpileModule = transpileModule;
function generateSourceMapForModule(moduleFilePath, destFilePath, transpileSourceMap) {
    var moduleSourceMap = readFileSourceMap(moduleFilePath + '.map');
    if (!utils_1.isNil(moduleSourceMap) && !utils_1.isNil(transpileSourceMap)) {
        var transpileRawSourceMap = utils_1.parseJSON(transpileSourceMap);
        var transpileSourceMapConsumer = new source_map_1.SourceMapConsumer(transpileRawSourceMap);
        var sourceMapConsumer = new source_map_1.SourceMapConsumer(moduleSourceMap);
        var sourceMapGenerator_1 = source_map_1.SourceMapGenerator.fromSourceMap(sourceMapConsumer);
        transpileSourceMapConsumer.eachMapping(function (mapping) {
            sourceMapGenerator_1.addMapping({
                generated: {
                    line: mapping.generatedLine,
                    column: mapping.generatedColumn,
                },
                original: {
                    line: mapping.originalLine,
                    column: mapping.originalColumn,
                },
                name: mapping.name,
                source: mapping.source,
            });
        });
        utils_1.writeFile(destFilePath + '.map', sourceMapGenerator_1.toString());
    }
}
exports.generateSourceMapForModule = generateSourceMapForModule;
function findOriginalMappingPosition(consumer, mapping) {
    var generated = mapping.generated;
    var original = consumer.originalPositionFor({
        line: generated.line,
        column: generated.column,
    });
    return original;
}
exports.findOriginalMappingPosition = findOriginalMappingPosition;
function readFileSourceMap(filePath) {
    if (utils_1.isFile(filePath)) {
        var fileContent = utils_1.readFile(filePath);
        return utils_1.parseJSON(fileContent);
    }
    return null;
}
exports.readFileSourceMap = readFileSourceMap;
